//: C14:Car.cpp
// From Thinking in C++, 2nd Edition
// Available at http://www.BruceEckel.com
// (c) Bruce Eckel 2000
// Copyright notice in Copyright.txt
// Public composition
// modified by i.m. on 9 nov 2008

#include <iostream>

using namespace std;

class Engine {      // variklis
  int power;        // galia
public:
  Engine(int p = 0) : power(p) {
    cout << "Engine konstruktorius\n";
  }
  ~Engine() {
    cout << "Engine destruktorius\n";
  }
  void start() const {}
  void rev() const {}
  void stop() const {}
};

class Wheels {      // ratai
  int size;         // dydis
public:
  Wheels(int s = 0) : size(s) {
    cout << "Wheels konstruktorius\n";
  }
  ~Wheels() {
    cout << "Wheels destruktorius\n";
  }
  void inflate(int psi) const {}    // pripusti
};

class Window {     // langas
  bool darkened;      // tamsinti
public:
  Window(bool d = false) : darkened(d) {
    cout << "Window konstruktorius\n";
  }
  ~Window() {
    cout << "Window destruktorius\n";
  }
  void rollup() const {}   // pakelti
  void rolldown() const {}    // nuleisti
};

class Door {       // durys
  bool front;      // priekines
public:
  Door( bool f = true, bool d = false ) : front(f), window(d) {
    cout << "Door konstruktorius\n";
  }
  ~Door() {
    cout << "Door destruktorius\n";
  }
  Window window;
  void open() const {}      // atidaryti
  void close() const {}      // uzdaryti
};

class Vehicle {      // transporto priemone
public:
  Vehicle( int ratai = 0 ) : wheels(ratai) {
    cout << "Vehicle konstruktorius\n";
  }
  ~Vehicle() {
    cout << "Vehicle destruktorius\n";
  }
  Wheels wheels;
  void go() const {}
  void stop() const {}
};

class Car : public Vehicle {    // masina
public:
  Car( int ratai = 0, int power = 0 ) : Vehicle( ratai ), engine( power ),
     left1( true, false ), right1( true, false ),
     left2( false, true ), right2( false, true ) {
    cout << "Car konstruktorius\n";
  }
  ~Car() {
    cout << "Car destruktorius\n";
  }
  Engine engine;
  Door left1, right1, left2, right2; // 4-door
};

int main() {

  Car audi( 16, 110 );
  Car bmw( 18, 300 );
  
  audi.wheels.inflate( 2 );
  audi.right2.window.rolldown();
  audi.engine.start();
  audi.go();
  
  bmw.left1.open();
  bmw.left1.close();
  bmw.engine.rev();
  bmw.go();
  
  audi.stop();
  audi.engine.stop();
  
} ///:~
